import "android.app.*"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
import "android.view.animation.*"
import "android.view.animation.Animation$AnimationListener"
--时,分动画
function setAnima(id,time)
  local s_z=TranslateAnimation(0, 0, -200, 0)
  s_z.setDuration(time)
  s_z.setFillAfter(true)
  s_z.setInterpolator(AnticipateOvershootInterpolator())
  id.startAnimation(s_z)
end

--秒动画
function setSAnima(id)
  local s_z=TranslateAnimation(0, 0, -200, 0)
  s_z.setDuration(475)
  s_z.setFillAfter(true)
  s_z.setInterpolator(AnticipateOvershootInterpolator())

  local z_t=TranslateAnimation(0,0,0,0)
  z_t.setDuration(475)
  z_t.setFillAfter(true)
  z_t.setInterpolator(LinearInterpolator())

  local z_x= AnimationSet(true)
  z_x_a=AlphaAnimation(1,0)
  z_x_a.setDuration(475)
  z_x_a.setFillAfter(true)
  z_x.addAnimation(z_x_a);
  z_x_y=TranslateAnimation(0,0,0,200)
  z_x_y.setDuration(475)
  z_x_y.setFillAfter(true)
  z_x_y.setInterpolator(LinearInterpolator())
  z_x.addAnimation(z_x_y);

  id.startAnimation(s_z)

  s_z.setAnimationListener(AnimationListener{
    onAnimationEnd=function()
      id.startAnimation(z_t)
    end,
  })
  z_t.setAnimationListener(AnimationListener{
    onAnimationEnd=function()
      id.startAnimation(z_x)
    end,
  })
end

function upData()
  H = os.date("%H")
  M = os.date("%M")
  S = os.date("%S")

  H_S = string.sub(H,1,1)
  H_G = string.sub(H,2,2)
  M_S = string.sub(M,1,1)
  M_G = string.sub(M,2,2)
  S_S = string.sub(S,1,1)
  S_G = string.sub(S,2,2)

  btn1.setText(H_S)
  btn2.setText(H_G)
  btn3.setText(M_S)
  btn4.setText(M_G)
  btn5.setText(S_S)
  btn6.setText(S_G)

  if O_H_S and O_H_G and O_M_S and O_M_G and O_S_S and O_S_G then
    if O_H_S~=H_S then
      setAnima(btn1125)
    end

    if O_H_G~=H_G then
      setAnima(btn2,475)
    end

    if O_M_S~=M_S then
      setAnima(btn3,475)
    end

    if O_M_G~=M_G then
      setAnima(btn4,475)
    end

    if O_S_S~=S_S then
      setAnima(btn5,475)
    end

    if O_S_G~=S_G then
      setSAnima(btn6)
    end
  end
  O_H_S = string.sub(H,1,1)
  O_H_G = string.sub(H,2,2)
  O_M_S = string.sub(M,1,1)
  O_M_G = string.sub(M,2,2)
  O_S_S = string.sub(S,1,1)
  O_S_G = string.sub(S,2,2)
end

thread(function()
  require "import"
  while(true) do
    call("upData")
    Thread.sleep(1000)
  end
end)


