require "import"
import "android.widget.*"
import "android.view.*"
import "android.graphics.Typeface"
import "android.graphics.drawable.ColorDrawable"
import "android.graphics.Color"
import "android.graphics.drawable.GradientDrawable"
import "java.io.File"
w=this.width
h=this.height
window=activity.getWindow()
DecorView=window.getDecorView()
pack_name=this.getPackageName()
window.clearFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS)
DecorView.setSystemUiVisibility(View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN|View.SYSTEM_UI_FLAG_LIGHT_STATUS_BAR)
window.addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS)
window.clearFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS)
window.setStatusBarColor(Color.TRANSPARENT)
window.setNavigationBarColor(0xFFFAFAFA)

--控件背景渐变
function 渐变(id,左色,右色)
  import "android.graphics.drawable.GradientDrawable"
  drawable = GradientDrawable(GradientDrawable.Orientation.TR_BL,{右色,左色});
  id.setBackgroundDrawable(drawable)
end

--点击效果
点击监听={
  onTouch=function (v,e)
    if e.action==0 then
      缩放动画(v,1,0.95,250)
     else
      缩放动画(v,0.95,1,250)
    end
  end}

function 缩放动画(view,startscale,endscale,time)
  local animatorSetsuofang = AnimatorSet()
  local scaleX=ObjectAnimator.ofFloat(view,"scaleX",{startscale,endscale})
  local scaleY=ObjectAnimator.ofFloat(view,"scaleY",{startscale,endscale})
  animatorSetsuofang.setDuration(time)
  animatorSetsuofang.setInterpolator(DecelerateInterpolator())
  animatorSetsuofang.play(scaleX).with(scaleY);
  animatorSetsuofang.start()
end
--点击效果

--输入框动画
function 输入框动画(id,位置Z,位置Y,起始点,动画时间)
  import "android.view.animation.*"--导入
  import "java.lang.Math"--导入
  import "com.androlua.Ticker"--导入
  --当有参数反馈时，则自动进行下列动画
  t=Ticker()
  t.Period=0
  t.start()
  t.onTick=function()
    t.stop()--停止
    --扩散原理和我发的揭露动画原理相同，利用圆形扩散
    animator = ViewAnimationUtils.createCircularReveal(id,位置Z,位置Y,起始点,id.getWidth());
    animator.setInterpolator(AccelerateInterpolator());
    animator.setDuration(700);
    animator.start();
  end
end

--提示弹窗
参数=0
function 提示(text)
  to={
    CardView;
    CardBackgroundColor="#FFffffff";
    elevation="8dp";
    layout_width="95%w";
    layout_height="42dp";
    radius="15";
    id="to";
    {
      TextView;
      textSize="15sp";
      TextColor="#FFa0a0a0";
      layout_width="95%w";
      layout_height="42dp";
      gravity="center";
      text="出错";
      id="texttc";
    };
  }
  local to=Toast.makeText(activity,"内容",Toast.LENGTH_SHORT).setView(loadlayout(to))
  --LENGTH_SHORT     2s
  --LENGTH_LONG      3.5s
  to.setGravity(Gravity.BOTTOM,0,60)
  --Gravity.BOTTOM   底部
  --Gravity.CENTER   中部
  --Gravity.TOP      顶部
  texttc.Text=tostring(text)
  to.show()
  参数=tonumber(os.time())
end

--弹窗圆角
function 弹窗圆角(控件,背景色,上角度,下角度)

  if not 上角度 then
    上角度=25
  end
  if not 下角度 then
    下角度=上角度
  end
  控件.setBackgroundDrawable(GradientDrawable()
  .setShape(GradientDrawable.RECTANGLE)
  .setColor(背景色)
  .setCornerRadii({上角度,上角度,上角度,上角度,下角度,下角度,下角度,下角度}))
end

--控件点击波纹函数
function ControlsCorrugated(id,color)
  import "android.content.res.ColorStateList"
  local attrsArray = {android.R.attr.selectableItemBackgroundBorderless}
  local typedArray =activity.obtainStyledAttributes(attrsArray)
  ripple=typedArray.getResourceId(0,0)
  Pretend=activity.Resources.getDrawable(ripple)
  Pretend.setColor(ColorStateList(int[0].class{int{}},int{color}))
  id.setBackground(Pretend.setColor(ColorStateList(int[0].class{int{}},int{color})))
end

--编辑框光标颜色修改
function EditBoxCursorColor(id,color)
  import "android.graphics.*"
  local mEditorField = TextView.getDeclaredField("mEditor")
  mEditorField.setAccessible(true)
  local mEditor = mEditorField.get(id)
  local field = Editor.getDeclaredField("mCursorDrawable")
  field.setAccessible(true)
  local mCursorDrawable = field.get(mEditor)
  local mccdf = TextView.getDeclaredField("mCursorDrawableRes")
  mccdf.setAccessible(true)
  local mccd = activity.getResources().getDrawable(mccdf.getInt(id))
  mccd.setColorFilter(PorterDuffColorFilter(color,PorterDuff.Mode.SRC_ATOP))
  mCursorDrawable[0] = mccd
  mCursorDrawable[1] = mccd
end




function 文件是否存在(a)
  return File(a).exists()
end

function 写入文件(a,b)
  io.open(a,"w"):write(b):close()
end

function 读取文件(a)
  return io.open(a):read("*a")
end